//+------------------------------------------------------------------+
//|                                  Spencer's 21 moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int  Price=PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double weights[]={-1,-3,-5,-5,-2,6,18,33,47,57,60,57,47,33,18,6,-2,-5,-5,-3,-1};

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,buffer1); SetIndexDrawBegin(0,7);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,10),Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double sum  = weights[10]*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = weights[10];
      for(int j=1; j<=10; j++)
      {
         sum  += weights[10-j]*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
         sumw += weights[10-j];

         if (j<=i)
         {
            sum  += weights[10+j]*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
            sumw += weights[10+j];
         }
      }
      buffer1[i] = sum/sumw;
   }            
   return(0);
}